package com.tongda.tdpimssdk.examples;

import com.alibaba.fastjson.JSON;
import com.tongda.tdpimssdk.entities.common.MetadataEntry;
import com.tongda.tdpimssdk.remote.entity.RemoteAsset;
import com.tongda.tdpimssdk.remote.paramset.AssetParamSet;
import com.tongda.tdpimssdk.remote.RemoteSaAuthHandler;

public class NewAssetSample {


    public static String reSetMetadataValue(RemoteSaAuthHandler rsa) {

        String id = "AST_1133043289746833408";

        System.out.println("1: 读取原始资产信息：" + id);
        RemoteAsset remoteAsset = RemoteAsset.doFetchAsset(rsa, id);
        System.out.println(remoteAsset);


        String mdk = "MDET_td_asset_number";
        System.out.println("2: 读取元数据信息: " + mdk);
        MetadataEntry mde = remoteAsset.getMetadataEntryByKey(mdk);
        System.out.println(JSON.toJSONString(mde));


        String mdk1 = "MDET_td_asset_name";
        String mdk2 = "MDET_responsible_department";

        System.out.println("3: 设置元数据信息：");
        System.out.println(mdk);
        System.out.println(mdk1);
        System.out.println(mdk2);

        remoteAsset.prepareMetadataUpdate()
                .setAssetField(new AssetParamSet.AssetField(mdk, "SN328333892323008"))
                .setAssetField(new AssetParamSet.AssetField(mdk1, "新的资产11名称"))
                .setAssetField(new AssetParamSet.AssetField(mdk2, "产品部"))
                .doAction();

        System.out.println("4:重新读取资产对象，输入元数据信息");

        RemoteAsset remoteAsset1 = RemoteAsset.doFetchAsset(rsa, id);
        MetadataEntry mde1 = remoteAsset1.getMetadataEntryByKey(mdk);
        MetadataEntry mde2 = remoteAsset1.getMetadataEntryByKey(mdk1);
        MetadataEntry mde3 = remoteAsset1.getMetadataEntryByKey(mdk2);
        System.out.println(JSON.toJSONString(mde1));
        System.out.println(JSON.toJSONString(mde2));
        System.out.println(JSON.toJSONString(mde3));

        return "Done";
    }

    public static String createAsset(RemoteSaAuthHandler rsa){
        String ret = RemoteAsset.prepareToCreateAsset(rsa,"ASTT_1112005016249434112", "第二个创建的资产", "EndUser-1128343251971997696")
                .setAssetField(new AssetParamSet.AssetField("MDET_td_asset_number", "资产编号987"))
                .setAssetField(new AssetParamSet.AssetField("MDET_td_data_center","北京一区"))
                .doAction();
        return ret;
    }

    public static void deleteAsset(RemoteSaAuthHandler rsa){
        String ret =RemoteAsset.doDeleteAsset(rsa,"AST-1149408193365934080");
        System.out.println(ret);
    }

    public static void assetUpgrade(RemoteSaAuthHandler rsa){

        String id = "AST_1133043289746833408";

        RemoteAsset remoteAsset = RemoteAsset.doFetchAsset(rsa,id);
        String s = remoteAsset.prepareUpgradeVersion()
                .setParamDesc("dddd")
                .doAction();

        System.out.println("升级版本：" + s);
    }

    public static void changeLifeCycleStatus(RemoteSaAuthHandler rsa){
        String id = "AST_1133043289746833408";
        RemoteAsset remoteAsset = RemoteAsset.doFetchAsset(rsa, id);

        String ret = remoteAsset.prepareChangeLifeCycleStatus()
                .setParamLifeCycleEvent("Edit")
                .doAction();

        System.out.println("生命周期: " + ret);
    }


    public static String id = "AST-1149381238067298304";
    public static void main(String[] args) {

        RemoteSaAuthHandler  rsa= new RemoteSaAuthHandler("guantiantian", "q1w2e3r4", "192.168.1.204", 9000);
        rsa.loginGetSaToken();

        rsa.setAppInstance("192.168.1.204", 8080, "TXPIMDB");
        System.out.println("登录数据" + rsa.toString());


        RemoteAsset remoteAsset = RemoteAsset.doFetchAsset(rsa, id);

        System.out.println(remoteAsset);

        /**  Todo
         * 创建资产
         */
      //  createAsset(rsa);

        /**  Todo
         * 修改资产元数据
         */
       // reSetMetadataValue(rsa);

        /**  Todo
         * 删除资产
         */
        //deleteAsset(rsa);

        /**  Todo
         * 变更生命周期
         */
        //changeLifeCycleStatus(rsa);

        /**  Todo
         * 升级版本
         */
        //assetUpgrade(rsa);


    }
}
