package com.tongda.tdpimssdk.examples;

import com.alibaba.fastjson.JSON;
import com.tongda.tdpimssdk.entities.common.MetadataEntry;
import com.tongda.tdpimssdk.remote.entity.RemoteDocument;
import com.tongda.tdpimssdk.remote.RemoteSaAuthHandler;
import com.tongda.tdpimssdk.remote.paramset.AssetParamSet;

import java.io.FileNotFoundException;

public class NewDocumentSample {

    public static void reSetMetadataValue(RemoteSaAuthHandler rsa){

        String id = "RES_1138885623029956608";
        RemoteDocument remoteDocument = RemoteDocument.doFetchDocument(rsa,id);

        MetadataEntry mde = remoteDocument.getMetadataEntryByKey("MDET_td_asset_number");
        System.out.println(JSON.toJSONString(mde));

        remoteDocument.prepareMetadataUpdate()
                .setAssetField(new AssetParamSet.AssetField("MDET_td_asset_number", "222"))
                .doAction();

        RemoteDocument remoteDocument1 =RemoteDocument.doFetchDocument(rsa,id);
        MetadataEntry mde1 = remoteDocument1.getMetadataEntryByKey("MDET_td_asset_number");

        System.out.println(JSON.toJSONString(mde1));
    }

    public static String createAsset(RemoteSaAuthHandler rsa){
        String ret = RemoteDocument.prepareToCreateDocument(rsa, "REST_1133463032148525056", "第二个创建的文档", "EndUser-1128343251971997696")
                .setAssetField(new AssetParamSet.AssetField("MDET_responsible_person_name", "刘晓光"))
                .setAssetField(new AssetParamSet.AssetField("MDET_operating_system","Windows"))
                .doAction();
        return ret;
    }

    public static void uploadBinary(RemoteSaAuthHandler rsa){

        String id = "RES_1133469381007769600";
        String filePath = "D:/video/DVR00564.MP4";
        RemoteDocument remoteDocument = RemoteDocument.doFetchDocument(rsa, id);
        try {
            String s = remoteDocument.prepareUploadBinary()
                    .setParamUploadFilePath(filePath)
                    .setParamMediaType("")
                    .doAction();
            System.out.println(s);
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }

    }

    public static String deleteDocument(RemoteSaAuthHandler rsa){
        String ret = RemoteDocument.doDeleteDocument(rsa,"RES-1149411645559144448");
        return ret;
    }

    public static String changeLifeCycleStatus(RemoteSaAuthHandler rsa){
//        String id = "RES_1133469381007769600";

        String id = "RES-1143952915883360256";

        RemoteDocument remoteDocument = RemoteDocument.doFetchDocument(rsa, id);

        String ret = remoteDocument.prepareChangeLifeCycleStatus()
                .setParamLifeCycleEvent("Edit")
                .doAction();

        return ret;
    }

    public static void upgradeDocument(RemoteSaAuthHandler rsa){
        String id = "RES_1133469381007769600";
        RemoteDocument remoteDocument = RemoteDocument.doFetchDocument(rsa,id);

        String s = remoteDocument.prepareUpgradeVersion()
                .setParamDesc("dddd")
                .doAction();

        System.out.println("升级版本：" + s);

    }

    public static void main(String[] args) {

        RemoteSaAuthHandler rsa = new RemoteSaAuthHandler("guantiantian", "q1w2e3r4", "192.168.1.204", 9000);
        rsa.loginGetSaToken();

        rsa.setAppInstance("192.168.1.204", 8080, "TXPIMDB");

        System.out.println("登录数据" + rsa.toString());


        RemoteDocument rd = RemoteDocument.doFetchDocument(rsa, "RES_1138887220686487552");

        System.out.println(JSON.toJSONString(rd));

        /**  Todo
         * 创建文档
         */
        //createAsset(rsa);

        /**  Todo
         * 修改元数据
         */
       //reSetMetadataValue(rsa);

        /**  Todo
         * 上载文件
         */
        //uploadBinary(rsa);

        /**  Todo
         * 删除文档
         */
       //deleteDocument(rsa);

        /**  Todo
         * 变更生命周期
         */
        //changeLifeCycleStatus(rsa);

        /**  Todo
         * 升级版本
         */
        //upgradeDocument(rsa);
    }
}
