package com.tongda.tdpimssdk.examples;

import com.tongda.tdpimssdk.remote.RemoteSaAuthHandler;
import com.tongda.tdpimssdk.remote.entity.RemoteTeam;

import java.util.ArrayList;
import java.util.List;

public class NewTeamSample {


    public static void createTeam(RemoteSaAuthHandler rsa){
       String ret = RemoteTeam.prepareToCreateTeam(rsa, "一个业务名称", "EndUser-1128343251971997696")
               .setParamDesc("dfdf")
               .setParamLifecycleID("TDLifeCycleDefinition-Common")
               .doAction();
        System.out.println(ret);
    }

    public static void upgradeVersion(RemoteSaAuthHandler rsa){

        String id = "Team2-1149734807001890816";

        RemoteTeam remoteTeam =  RemoteTeam.doFetchTeam(rsa, id);

        String ret = remoteTeam.prepareUpgradeVersion()
                .setParamDesc("ddd")
                .doAction();

        System.out.println(ret);
    }

    public static void changeLifeCycle(RemoteSaAuthHandler rsa){

        String id = "Team2-1149734807001890816";

        RemoteTeam remoteTeam =  RemoteTeam.doFetchTeam(rsa, id);

        String ret = remoteTeam.prepareChangeLifeCycleStatus()
                .setParamLcEvent("Edit")
                .doAction();

        System.out.println("changeLifeCycle:"  + ret);
    }

    public static void addAssetRefToTeam(RemoteSaAuthHandler rsa){

        String id = "Team2-1149751594825285632";

        RemoteTeam remoteTeam =  RemoteTeam.doFetchTeam(rsa, id);

        List<String> asl = new ArrayList<>();
        asl.add("AST-1149381713307107328");

        String ret = remoteTeam.prepareAddAssetRef()
                .setParamAssetListToAdd(asl)
                .doAction();

        System.out.println("addAssetRefToTeam:"  + ret);
    }

    public static void removeAssetRefToTeam(RemoteSaAuthHandler rsa){

        String id = "Team2-1149751594825285632";

        RemoteTeam remoteTeam =  RemoteTeam.doFetchTeam(rsa, id);


        String ret = remoteTeam.prepareRemoveAssetRef()
                .setParamAssetToRemove("AST-1149381238067298304")
                .doAction();

        System.out.println("removeAssetRefToTeam:"  + ret);
    }

    public static void deleteTeam(RemoteSaAuthHandler rsa){
        String ret = RemoteTeam.doDeleteTeam(rsa,"TEM_1138448201645293568");
        System.out.println("deleteTeam:" + ret);
    }

    public static void main(String[] args) {
        RemoteSaAuthHandler rsa = new RemoteSaAuthHandler("guantiantian", "q1w2e3r4", "192.168.1.204", 9000);
        rsa.loginGetSaToken();
        rsa.setAppInstance("192.168.1.204", 8080, "TXPIMDB");
        System.out.println("登录数据" + rsa.toString());

        //初始化远程查询对象
      //  RemoteTDDamHelper rqh = new RemoteTDDamHelper(rsa);

       // RemoteTeam remoteTeam =  rqh.fetchTeam("TEM_1129497138993037312");

        RemoteTeam remoteTeam =  RemoteTeam.doFetchTeam(rsa, "TEM_1129497138993037312");

        System.out.println(remoteTeam);




        /**  Todo
         * 创建业务
         */
        //createTeam(rqh);

        /**  Todo
         * 添加资产/文档
         */
        //addAssetRefToTeam(rqh);

        /**  Todo
         * 移除资产/文档
         */
        //removeAssetRefToTeam(rqh);

        /**  Todo
         * 变更生命周期
         */
        //changeLifeCycle(rqh);


        /**  Todo
         * 提升版本
         */
       //upgradeVersion(rqh);

        /**  Todo
         * 删除业务
         */
        //deleteTeam(rqh);

    }
}
