package com.tongda.tdpimssdk.remote.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.remote.RemoteSaAuthHandler;
import com.tongda.tdpimssdk.remote.common.RemoteAbstractEntity;
import com.tongda.tdpimssdk.remote.paramset.AssetParamSet;
import com.tongda.tdpimssdk.remote.paramset.TeamParamSet;
import lombok.Data;

import static com.tongda.tdpimssdk.http.PimHttpUtil.resultUtil;

@Data
public class RemoteAsset extends RemoteAbstractEntity {
    public static final String METADATA_URI = "/pims/asset/field";
    public static final String BASE_URI = "/pims/asset";
    public static final String BASE_URI_UPGRADE = "/pims/asset/upgrade";
    public static final String BASE_URI_LIFECYCLE = "/pims/lifecycle/asset/state";



    public String toString(){
        return JSON.toJSONString(this);
    }

    public AssetParamSet prepareMetadataUpdate(){
        this.assetVo= new AssetParamSet(this.getRsh(), AssetParamSet.action_asset_metadata_update);
        this.assetVo.setId(this.getId());
        return this.assetVo;
    }

    public AssetParamSet prepareUpgradeVersion(){
        this.assetVo= new AssetParamSet(this.getRsh(), AssetParamSet.action_asset_upgrade);
        this.assetVo.setId(this.getId());
        return this.assetVo;
    }

    public AssetParamSet prepareChangeLifeCycleStatus() {
        this.assetVo= new AssetParamSet(this.getRsh(), AssetParamSet.action_asset_change_lifecycle);
        this.assetVo.setId(this.getId());
        return this.assetVo;
    }


    public static RemoteAsset doFetchAsset(RemoteSaAuthHandler rsa, String assetID){
        String url = "http://" +rsa.serverIP + ":" + rsa.serverPort + "/pims/asset/details?dbName=" + rsa.dbName + "&id=" + assetID;
        String response = PimHttpUtil.sendGet(rsa.saToken, url);
        String s = resultUtil(response);
        RemoteAsset ra = JSONObject.parseArray(s, RemoteAsset.class).get(0);
        ra.setRsh(rsa);
        return ra;
    }

    public static String doDeleteAsset(RemoteSaAuthHandler rsa, String id) {
        AssetParamSet param = new AssetParamSet(rsa, AssetParamSet.action_document_delete);
        param.setId(id);
        return param.doAction();
    }

    public static AssetParamSet prepareToCreateAsset(RemoteSaAuthHandler rsa, String templateID, String label, String creatorID) {
        AssetParamSet param = new AssetParamSet(rsa, AssetParamSet.action_asset_create);
        param.setParamTemplate(templateID)
                .setParamLabel(label)
                .setParamUserID(creatorID);
        return param;
    }
}
