package com.tongda.tdpimssdk.remote.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.tongda.tdpimssdk.http.PimHttpUtil;
import com.tongda.tdpimssdk.remote.RemoteSaAuthHandler;
import com.tongda.tdpimssdk.remote.common.RemoteAbstractTeam;
import com.tongda.tdpimssdk.remote.paramset.TeamParamSet;

import static com.tongda.tdpimssdk.http.PimHttpUtil.resultUtil;

public class RemoteTeam extends RemoteAbstractTeam {

    public static final String BASE_URI_ASSET = "/pims/business/asset";

    public static final String BASE_URI = "/pims/business";

    public static final String BASE_URI_UPGRADE_VERSION= "/pims/business/upgrade";

    public static final String BASE_URI_LIFECYCLE = "/pims/lifecycle/team/state";




    public String toString(){
        return JSON.toJSONString(this);
    }


    public TeamParamSet prepareUpgradeVersion(){
        this.paramVo= new TeamParamSet(this.getRsh(), TeamParamSet.action_team_upgrade_version);
        this.paramVo.setTeamID(this.getId());
        return this.paramVo;
    }

    public TeamParamSet prepareChangeLifeCycleStatus(){
        this.paramVo= new TeamParamSet(this.getRsh(), TeamParamSet.action_team_change_lifecycle);
        this.paramVo.setTeamID(this.getId());
        return this.paramVo;
    }

    public TeamParamSet prepareAddAssetRef(){
        this.paramVo= new TeamParamSet(this.getRsh(), TeamParamSet.action_team_add_asset_ref);
        this.paramVo.setTeamID(this.getId());
        return this.paramVo;
    }

    public TeamParamSet prepareRemoveAssetRef(){
        this.paramVo= new TeamParamSet(this.getRsh(), TeamParamSet.action_team_remove_asset_ref);
        this.paramVo.setTeamID(this.getId());
        return this.paramVo;
    }


    public static RemoteTeam doFetchTeam(RemoteSaAuthHandler rsa, String teamID){
        String url = "http://" + rsa.serverIP + ":" + rsa.serverPort + "/pims/business/details?dbName=" + rsa.dbName + "&id=" + teamID;
        String response = PimHttpUtil.sendGet(rsa.saToken, url);
        String s = resultUtil(response);
        RemoteTeam team =  JSONObject.parseArray(s, RemoteTeam.class).get(0);
        team.setRsh(rsa);
        return team;
    }

    public static String doDeleteTeam(RemoteSaAuthHandler rsa, String id) {
        TeamParamSet param = new TeamParamSet(rsa, TeamParamSet.action_team_delete);
        param.setTeamID(id);
        return param.doAction();
    }

    public static TeamParamSet prepareToCreateTeam(RemoteSaAuthHandler rsa, String label, String creatorID) {
        TeamParamSet param = new TeamParamSet(rsa, TeamParamSet.action_team_create);
        param.setParamLabel(label)
                .setParamUserID(creatorID);
        return param;
    }



}
