package com.tongda.tdpimssdk.resultVo.vo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.List;

/**
 * @Tittle: AssetVo
 * @description:
 * @Package: com.tongda.pimdemo.http.resultVo.vo
 * @Date 2023/5/25 19:10
 */
@Data
public class AssetVo {
    // 模型ID
    private String templateID;
    // 资产ID
    private String id;
    // 模型名称
    private String label;
    private String userID;
    private String userName;

    private List<AssetField> fields;


    public void addAssetField(AssetField field){
        if(fields == null){
            this.fields = new ArrayList<>();
        }
        this.fields.add(field);
    }

    /**
     * '[
     * {"key": "tdpim.asset.mainframe.cpu.count", "type":"SingleValue", "value":"6"},
     * {"key": "tdpim.asset.mainframe.cpu.temp", "type":"Range", "valueMin":"1", "valueMax":"5"},
     * {"key": "tdpim.asset.mainframe.area", "type":"MultiSelect", "selectedIDs":["CandidateValue-1110951999471353858","CandidateValue-1110951999471353859"]}
     */
    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    public static class AssetField {

        //元数据Key
        private String key;

        //元数据模式
        private String mode;  //元数据模式

        //元数据据计量单位
        private String uom;


//单值
        private String value;

// 范围

        private String valueMin;
        private String valueMax;


// 多选
        private List<String> selectedIDs;


        public void setIntegerValue(Integer value){
            this.setValue(String.valueOf(value));
        }

        public void setFloatValue(Float value){
            this.setValue(String.valueOf(value));
        }

        public void setMinValue(Integer value){
            this.setValueMin(String.valueOf(value));
        }

        public void setMinValue(Float value){
            this.setValueMin(String.valueOf(value));
        }

        public void setMaxValue(Integer value){
            this.setValueMax(String.valueOf(value));
        }

        public void setMaxValue(Float value){
            this.setValueMax(String.valueOf(value));
        }

        public void setMultiValue(Integer[] value){
            String v = "";
            for(Integer i : value){
                v += String.valueOf(i) + ";";
            }
            this.setValue(v);
        }

        public void setMultiValue(Float[] value){
            String v = "";
            for(Float i : value){
                v += String.valueOf(i) + ";";
            }
            this.setValue(v);
        }

        public void setMultiValue(String[] value){
            String v = "";
            for(String i : value){
                v += i + ";";
            }
            this.setValue(v);
        }

    }

}
